# AUTHOR: Filippo Piccinini
# DATA: 20210226
# NOTE: Example of a possible solution of a typical exercise of a "Rexam - CLEF - Piccinini".

# Clear workspace
rm(list=ls())

# Create the matrix
vect1<-c(12, 11, 10, 9, 8, 10, 6, 5, 10, 3, 2, 10)
mat1<-matrix(vect1, byrow = FALSE, nrow = 3)
mat1

# Name the columns
colnames(mat1)<-c("day0", "day1", "day2", "day3")

# Name the rows
rownames(mat1)<-c("first", "second", "third")
mat1

# Alternative
conames<-c("day0", "day1", "day2", "day3")
ronames<-c("first", "second", "third")
mat1<-matrix(c(12, 11, 10, 9, 8, 10, 6, 5, 10, 3, 2, 10), byrow = FALSE, nrow = 3, dimnames = list(ronames,conames))
mat1

# Compute the sum by row
sumValues<- colSums(mat1)
sumValues

# Compute the sum with a for cycle
i<-1
j<-1
sumValues<-c()
for(i in 1:ncol(mat1)){
  sumValue<-0
  for(j in 1:nrow(mat1)){
    sumValue<-sumValue+mat1[j,i]
  }
  sumValues<-c(sumValues,sumValue)
}
sumValues

# Extract some values using the column and row names
extractedValues<- mat1[c("second","third"),"day2"]
extractedValues

# Extract some values using the matrix indeces
extractedValues<- mat1[2:3,3]
extractedValues